package jdomain.jdraw.action;

import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;

import javax.swing.KeyStroke;

import jdomain.jdraw.Main;
import jdomain.jdraw.data.Picture;
import jdomain.jdraw.gui.MainFrame;
import jdomain.jdraw.gui.PixelTool;
import jdomain.jdraw.gui.ToolPanel;
import jdomain.jdraw.gui.undo.UndoManager;
import jdomain.util.Log;

/*
 * SetMaxZoomAction.java - created on 29.10.2003
 * 
 * @author Michaela Behling
 */

public class NewAction extends DrawAction {

	/** */
   private static final long serialVersionUID = 1L;

   protected NewAction() {
		super("New", "new.png");
		setToolTipText("Creates a new empty image");
		setAccelerators(
			new KeyStroke[] {
				 KeyStroke.getKeyStroke(new Character('N'), KeyEvent.CTRL_MASK)});
	}

	public void actionPerformed(ActionEvent e) {
		ToolPanel.INSTANCE.setCurrentTool(
			PixelTool.INSTANCE,
			DrawAction.getAction(SetPixelToolAction.class));
		MainFrame.INSTANCE.setFileName(null);
		Main.setPicture(Picture.createDefaultPicture());
		UndoManager.INSTANCE.reset();
		Log.info("New image created.");
	}

}
