package jdomain.jdraw.action;

import java.awt.event.ActionEvent;

import jdomain.jdraw.data.Frame;
import jdomain.jdraw.data.Picture;
import jdomain.jdraw.gui.Tool;
import jdomain.util.Log;

/*
 * ToggleLocalPaletteAction.java - created on 29.10.2003
 * 
 * @author Michaela Behling
 */

public class ToggleLocalPaletteAction extends DrawAction {

	/** */
   private static final long serialVersionUID = 1L;

   protected ToggleLocalPaletteAction() {
		super("Create Local Palette");
		setToolTipText("Creates a local palette for this frame");
	}

	public void actionPerformed(ActionEvent e) {
		Picture pic = Tool.getPicture();
		Frame frame = pic.getCurrentFrame();

		frame.toggleLocalPalette();
		if (frame.getPalette().isGlobalPalette()) {
			putValue(NAME, "Create Local Palette");
			Log.info("Using global palette.");
		}
		else {
			putValue(NAME, "Discard Local Palette");
			Log.info("Using local palette.");
		}
	}

}
